"use strict";
var Container = require('./container');
var AtRule = function AtRule(defaults) {
  this.type = 'atrule';
  $traceurRuntime.superCall(this, $AtRule.prototype, "constructor", [defaults]);
};
var $AtRule = AtRule;
($traceurRuntime.createClass)(AtRule, {
  styleType: function() {
    return this.type + ((this.rules || this.decls) ? '-body' : '-bodiless');
  },
  defaultStyle: function(type) {
    if (type == 'atrule-body') {
      return {
        between: ' ',
        after: this.defaultAfter()
      };
    } else {
      return {between: ''};
    }
  },
  addMixin: function(type) {
    var mixin = type == 'rules' ? Container.WithRules : Container.WithDecls;
    if (!mixin)
      return;
    for (var name in mixin.prototype) {
      if (name == 'constructor')
        continue;
      var value = mixin.prototype[name];
      var container = Container.prototype[name] == value;
      var detector = name == 'append' || name == 'prepend';
      if (container && !detector)
        continue;
      this[name] = value;
    }
    mixin.apply(this);
  },
  stringify: function(builder, last) {
    var style = this.style();
    var name = '@' + this.name;
    var params = this.params ? this.stringifyRaw('params') : '';
    if (typeof(this.afterName) != 'undefined') {
      name += this.afterName;
    } else if (params) {
      name += ' ';
    }
    if (this.rules || this.decls) {
      this.stringifyBlock(builder, name + params + style.between + '{');
    } else {
      if (this.before)
        builder(this.before);
      var semicolon = (!last || this.semicolon) ? ';' : '';
      builder(name + params + style.between + semicolon, this);
    }
  },
  append: function(child) {
    var mixin = child.type == 'decl' ? 'decls' : 'rules';
    this.addMixin(mixin);
    return this.append(child);
  },
  prepend: function(child) {
    var mixin = child.type == 'decl' ? 'decls' : 'rules';
    this.addMixin(mixin);
    return this.prepend(child);
  }
}, {}, Container);
module.exports = AtRule;
