"use strict";
var list = {
  split: function(string, separators, last) {
    var array = [];
    var current = '';
    var split = false;
    var func = 0;
    var quote = false;
    var escape = false;
    for (var i = 0; i < string.length; i++) {
      var letter = string[i];
      if (quote) {
        if (escape) {
          escape = false;
        } else if (letter == '\\') {
          escape = true;
        } else if (letter == quote) {
          quote = false;
        }
      } else if (letter == '"' || letter == "'") {
        quote = letter;
      } else if (letter == '(') {
        func += 1;
      } else if (letter == ')') {
        if (func > 0)
          func -= 1;
      } else if (func === 0) {
        for (var $__0 = separators[Symbol.iterator](),
            $__1; !($__1 = $__0.next()).done; ) {
          var separator = $__1.value;
          {
            if (letter == separator)
              split = true;
          }
        }
      }
      if (split) {
        if (current !== '')
          array.push(current.trim());
        current = '';
        split = false;
      } else {
        current += letter;
      }
    }
    if (last || current !== '')
      array.push(current.trim());
    return array;
  },
  space: function(string) {
    return this.split(string, [' ', "\n", "\t"]);
  },
  comma: function(string) {
    return this.split(string, [','], true);
  }
};
module.exports = list;
