"use strict";
var Declaration = require('./declaration');
var Comment = require('./comment');
var AtRule = require('./at-rule');
var Result = require('./result');
var Rule = require('./rule');
var Root = require('./root');
var PostCSS = function PostCSS() {
  var processors = arguments[0] !== (void 0) ? arguments[0] : [];
  this.processors = processors;
};
($traceurRuntime.createClass)(PostCSS, {
  use: function(processor) {
    this.processors.push(processor);
    return this;
  },
  process: function(css) {
    var opts = arguments[1] !== (void 0) ? arguments[1] : {};
    if (opts.map == 'inline')
      opts.map = {inline: true};
    var parsed;
    if (css instanceof Root) {
      parsed = css;
    } else if (css instanceof Result) {
      parsed = css.root;
    } else {
      parsed = postcss.parse(css, opts);
    }
    for (var $__1 = this.processors[Symbol.iterator](),
        $__2; !($__2 = $__1.next()).done; ) {
      var processor = $__2.value;
      {
        var returned = processor(parsed);
        if (returned instanceof Root)
          parsed = returned;
      }
    }
    return parsed.toResult(opts);
  }
}, {});
var postcss = function() {
  for (var processors = [],
      $__3 = 0; $__3 < arguments.length; $__3++)
    processors[$__3] = arguments[$__3];
  return new PostCSS(processors);
};
postcss.parse = require('./parse');
postcss.comment = function(defaults) {
  return new Comment(defaults);
};
postcss.atRule = function(defaults) {
  return new AtRule(defaults);
};
postcss.decl = function(defaults) {
  return new Declaration(defaults);
};
postcss.rule = function(defaults) {
  return new Rule(defaults);
};
postcss.root = function(defaults) {
  return new Root(defaults);
};
module.exports = postcss;
